(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('ngx-editor/commands', ['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ngx-editor'] = global['ngx-editor'] || {}, global['ngx-editor'].commands = {})));
}(this, (function (exports) { 'use strict';

    var removeLink = function () {
        return function (state, dispatch) {
            var doc = state.doc, selection = state.selection, tr = state.tr;
            var pos = selection.$head.pos, from = selection.from, to = selection.to;
            // if the cursor is on the link without any selection
            if (from === to) {
                var $pos = doc.resolve(pos);
                var linkStart = pos - $pos.textOffset;
                var linkEnd = linkStart + $pos.parent.child($pos.index()).nodeSize;
                tr.removeMark(linkStart, linkEnd);
            }
            else {
                tr.removeMark(from, to);
            }
            if (!tr.docChanged) {
                return false;
            }
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(tr);
            return true;
        };
    };

    /**
     * Generated bundle index. Do not edit.
     */

    exports.removeLink = removeLink;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-editor-commands.umd.js.map
