(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prosemirror-state'), require('prosemirror-view'), require('ngx-editor/helpers'), require('ngx-editor/commands')) :
    typeof define === 'function' && define.amd ? define('ngx-editor/plugins', ['exports', 'prosemirror-state', 'prosemirror-view', 'ngx-editor/helpers', 'ngx-editor/commands'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ngx-editor'] = global['ngx-editor'] || {}, global['ngx-editor'].plugins = {}), global.prosemirrorState, global.prosemirrorView, global['ngx-editor'].helpers, global['ngx-editor'].commands));
}(this, (function (exports, prosemirrorState, prosemirrorView, helpers, commands) { 'use strict';

    var DEFAULT_PLACEHOLDER = 'Type Here...';
    var PLACEHOLDER_CLASSNAME = 'NgxEditor__Placeholder';
    var placeholderPlugin = function (text) {
        if (text === void 0) { text = DEFAULT_PLACEHOLDER; }
        return new prosemirrorState.Plugin({
            key: new prosemirrorState.PluginKey('placeholder'),
            props: {
                decorations: function (state) {
                    var _a;
                    var doc = state.doc;
                    if (doc.childCount === 1 && ((_a = doc === null || doc === void 0 ? void 0 : doc.firstChild) === null || _a === void 0 ? void 0 : _a.isTextblock) && doc.firstChild.content.size === 0) {
                        var placeHolderEl = document.createElement('span');
                        placeHolderEl.classList.add(PLACEHOLDER_CLASSNAME);
                        placeHolderEl.textContent = text;
                        return prosemirrorView.DecorationSet.create(doc, [prosemirrorView.Decoration.widget(1, placeHolderEl)]);
                    }
                    return prosemirrorView.DecorationSet.empty;
                }
            }
        });
    };
    var ɵ0 = placeholderPlugin;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var LinkOptions = /** @class */ (function () {
        function LinkOptions(view) {
            this.bubbleEL = document.createElement('div');
            this.render(view);
            this.update(view);
        }
        LinkOptions.prototype.render = function (view) {
            var _a;
            this.bubbleEL.className = 'NgxEditor__FloatingBubble';
            (_a = view.dom.parentNode) === null || _a === void 0 ? void 0 : _a.appendChild(this.bubbleEL);
        };
        LinkOptions.prototype.setDomPosition = function (view) {
            // Otherwise, reposition it and update its content
            this.bubbleEL.style.display = '';
            var _b = helpers.calculateBubblePos(view, this.bubbleEL), bottom = _b.bottom, left = _b.left;
            this.bubbleEL.style.left = left + 'px';
            this.bubbleEL.style.bottom = bottom + 'px';
        };
        LinkOptions.prototype.createLinkNode = function (item, removeCB) {
            var el = document.createDocumentFragment();
            var link = document.createElement('a');
            link.href = item.attrs.href;
            link.target = '_blank';
            link.innerText = item.attrs.href;
            link.title = item.attrs.href;
            link.addEventListener('mousedown', function (e) {
                e.preventDefault();
                e.stopPropagation();
            }, { once: true });
            var commands = document.createElement('div');
            commands.classList.add('commands');
            var removeOpt = document.createElement('button');
            removeOpt.textContent = 'Remove Link';
            removeOpt.title = 'Remove link';
            removeOpt.classList.add('command');
            removeOpt.addEventListener('mousedown', removeCB, { once: true });
            commands.appendChild(removeOpt);
            el.appendChild(link);
            el.appendChild(commands);
            return el;
        };
        LinkOptions.prototype.clearBubbleContent = function () {
            this.bubbleEL.textContent = '';
        };
        LinkOptions.prototype.hideBubble = function () {
            this.bubbleEL.style.display = 'none';
        };
        LinkOptions.prototype.update = function (view) {
            var state = view.state, dispatch = view.dispatch;
            var schema = state.schema, selection = state.selection;
            if (!schema.marks.link) {
                return;
            }
            if (selection instanceof prosemirrorState.NodeSelection) {
                if (selection.node.type.name === 'image') {
                    return;
                }
            }
            var hasFocus = view.hasFocus();
            var isActive = helpers.isLinkActive(state);
            var linkMarks = helpers.getSelectionMarks(state).filter(function (mark) { return mark.type === schema.marks.link; });
            // hide for selection and show only for clicks
            if (!hasFocus || !isActive) {
                this.hideBubble();
                return;
            }
            var _b = __read(linkMarks, 1), linkItem = _b[0];
            this.clearBubbleContent();
            var removeCB = function (e) {
                e.preventDefault();
                e.stopPropagation();
                if (e.button !== 0) {
                    return;
                }
                commands.removeLink()(state, dispatch);
                view.focus();
            };
            var el = this.createLinkNode(linkItem, removeCB);
            this.bubbleEL.appendChild(el);
            // update dom position
            this.setDomPosition(view);
        };
        LinkOptions.prototype.destroy = function () {
            this.bubbleEL.remove();
        };
        return LinkOptions;
    }());
    var linkPlugin = function () {
        return new prosemirrorState.Plugin({
            key: new prosemirrorState.PluginKey('link'),
            view: function (editorView) {
                return new LinkOptions(editorView);
            },
            props: {
                handleDOMEvents: {
                    blur: function (view) {
                        // dummy transaction to update
                        view.dispatch(view.state.tr.setMeta('LINK_PLUGIN_EDITOR_BLUR', true));
                        return false;
                    }
                }
            }
        });
    };
    var ɵ0$1 = linkPlugin;

    var WRAPPER_CLASSNAME = 'NgxEditor__ImageWrapper';
    var WRAPPER_RESIZE_ACTIVE_CLASSNAME = 'NgxEditor__Resizer--Active';
    var RESIZE_HANDLE_CLASSNAME = 'NgxEditor__ResizeHandle';
    var ImageRezieView = /** @class */ (function () {
        function ImageRezieView(node, view, getPos) {
            var _a, _b;
            var outer = document.createElement('span');
            outer.className = WRAPPER_CLASSNAME;
            outer.style.width = node.attrs.width;
            var handle = document.createElement('span');
            handle.className = RESIZE_HANDLE_CLASSNAME;
            var img = document.createElement('img');
            img.setAttribute('src', node.attrs.src);
            img.setAttribute('alt', (_a = node.attrs.alt) !== null && _a !== void 0 ? _a : '');
            img.setAttribute('title', (_b = node.attrs.title) !== null && _b !== void 0 ? _b : '');
            img.style.width = '100%';
            var handleBottomRight = document.createElement('span');
            var handleTopRight = document.createElement('span');
            var handleTopLeft = document.createElement('span');
            var handleBottomLeft = document.createElement('span');
            handleBottomRight.className = RESIZE_HANDLE_CLASSNAME + "--BR";
            handleTopRight.className = RESIZE_HANDLE_CLASSNAME + "--TR";
            handleTopLeft.className = RESIZE_HANDLE_CLASSNAME + "--TL";
            handleBottomLeft.className = RESIZE_HANDLE_CLASSNAME + "--BL";
            var resizePropoptionally = function (evt) {
                evt.preventDefault();
                var state = view.state, dispatch = view.dispatch;
                var tr = state.tr;
                var startX = evt.pageX;
                var startWidth = img.clientWidth;
                var width = window.getComputedStyle(view.dom).width;
                var editorWidth = parseInt(width, 10);
                var onMouseMove = function (e) {
                    var currentX = e.pageX;
                    var diffInPx = currentX - startX;
                    var computedWidth = startWidth + diffInPx;
                    // prevent image overflow the editor
                    // prevent resizng below 20px
                    if (computedWidth > editorWidth || computedWidth < 20) {
                        return;
                    }
                    outer.style.width = computedWidth + "px";
                };
                var onMouseUp = function (e) {
                    e.preventDefault();
                    document.removeEventListener('mousemove', onMouseMove);
                    document.removeEventListener('mouseup', onMouseUp);
                    var transaction = tr.setNodeMarkup(getPos(), null, {
                        src: node.attrs.src,
                        width: outer.style.width
                    });
                    var resolvedPos = transaction.doc.resolve(getPos());
                    var newSelection = new prosemirrorState.NodeSelection(resolvedPos);
                    transaction.setSelection(newSelection);
                    dispatch(transaction);
                };
                document.addEventListener('mousemove', onMouseMove);
                document.addEventListener('mouseup', onMouseUp);
            };
            handleBottomRight.addEventListener('mousedown', resizePropoptionally, { once: true });
            handleTopRight.addEventListener('mousedown', resizePropoptionally, { once: true });
            handleTopLeft.addEventListener('mousedown', resizePropoptionally, { once: true });
            handleBottomLeft.addEventListener('mousedown', resizePropoptionally, { once: true });
            handle.appendChild(handleBottomRight);
            handle.appendChild(handleTopRight);
            handle.appendChild(handleTopLeft);
            handle.appendChild(handleBottomLeft);
            outer.appendChild(handle);
            outer.appendChild(img);
            this.dom = outer;
            this.img = img;
            this.handle = handle;
        }
        ImageRezieView.prototype.selectNode = function () {
            this.dom.classList.add(WRAPPER_RESIZE_ACTIVE_CLASSNAME);
            this.handle.style.display = 'block';
        };
        ImageRezieView.prototype.deselectNode = function () {
            this.dom.classList.remove(WRAPPER_RESIZE_ACTIVE_CLASSNAME);
            this.handle.style.display = 'none';
        };
        return ImageRezieView;
    }());
    var defaultOptions = {
        resize: true,
    };
    var imagePlugin = function (opts) {
        if (opts === void 0) { opts = defaultOptions; }
        var options = Object.assign(Object.assign({}, defaultOptions), opts);
        return new prosemirrorState.Plugin({
            key: new prosemirrorState.PluginKey('link'),
            props: {
                nodeViews: {
                    image: function (node, view, getPos) {
                        if (!options.resize) {
                            return null;
                        }
                        return new ImageRezieView(node, view, getPos);
                    },
                }
            }
        });
    };
    var ɵ0$2 = imagePlugin;

    /**
     * Generated bundle index. Do not edit.
     */

    exports.imagePlugin = imagePlugin;
    exports.link = linkPlugin;
    exports.placeholder = placeholderPlugin;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-editor-plugins.umd.js.map
